# stl_relops.h

Go to the documentation of this file.

    00001 // std::rel_ops implementation -*- C++ -*-
    00002
    00003 // Copyright (C) 2001, 2002, 2004 Free Software Foundation, Inc.
    00004 //
    00005 // This file is part of the GNU ISO C++ Library.  This library is free
    00006 // software; you can redistribute it and/or modify it under the
    00007 // terms of the GNU General Public License as published by the
    00008 // Free Software Foundation; either version 2, or (at your option)
    00009 // any later version.
    00010
    00011 // This library is distributed in the hope that it will be useful,
    00012 // but WITHOUT ANY WARRANTY; without even the implied warranty of
    00013 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    00014 // GNU General Public License for more details.
    00015
    00016 // You should have received a copy of the GNU General Public License along
    00017 // with this library; see the file COPYING.  If not, write to the Free
    00018 // Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,
    00019 // USA.
    00020
    00021 // As a special exception, you may use this file as part of a free software
    00022 // library without restriction.  Specifically, if other files instantiate
    00023 // templates or use macros or inline functions from this file, or you compile
    00024 // this file and link it with other files to produce an executable, this
    00025 // file does not by itself cause the resulting executable to be covered by
    00026 // the GNU General Public License.  This exception does not however
    00027 // invalidate any other reasons why the executable file might be covered by
    00028 // the GNU General Public License.
    00029
    00030 /*
    00031  *
    00032  * Copyright (c) 1994
    00033  * Hewlett-Packard Company
    00034  *
    00035  * Permission to use, copy, modify, distribute and sell this software
    00036  * and its documentation for any purpose is hereby granted without fee,
    00037  * provided that the above copyright notice appear in all copies and
    00038  * that both that copyright notice and this permission notice appear
    00039  * in supporting documentation.  Hewlett-Packard Company makes no
    00040  * representations about the suitability of this software for any
    00041  * purpose.  It is provided "as is" without express or implied warranty.
    00042  *
    00043  * Copyright (c) 1996,1997
    00044  * Silicon Graphics
    00045  *
    00046  * Permission to use, copy, modify, distribute and sell this software
    00047  * and its documentation for any purpose is hereby granted without fee,
    00048  * provided that the above copyright notice appear in all copies and
    00049  * that both that copyright notice and this permission notice appear
    00050  * in supporting documentation.  Silicon Graphics makes no
    00051  * representations about the suitability of this software for any
    00052  * purpose.  It is provided "as is" without express or implied warranty.
    00053  *
    00054  */
    00055
    00056 /** @file stl_relops.h
    00057  *  This is an internal header file, included by other library headers.
    00058  *  You should not attempt to use it directly.
    00059  *
    00060  *  @if maint
    00061  *  Inclusion of this file has been removed from
    00062  *  all of the other STL headers for safety reasons, except std_utility.h.
    00063  *  For more information, see the thread of about twenty messages starting
    00064  *  with http://gcc.gnu.org/ml/libstdc++/2001-01/msg00223.html , or the
    00065  *  FAQ at http://gcc.gnu.org/onlinedocs/libstdc++/faq/index.html#4_4 .
    00066  *
    00067  *  Short summary:  the rel_ops operators should be avoided for the present.
    00068  *  @endif
    00069  */
    00070
    00071 #ifndef _STL_RELOPS_H
    00072 #define _STL_RELOPS_H 1
    00073
    00074 namespace std
    00075 {
    00076   namespace rel_ops
    00077   {
    00078     /** @namespace std::rel_ops
    00079      *  @brief  The generated relational operators are sequestered here.
    00080      */
    00081
    00082     /**
    00083      *  @brief Defines @c != for arbitrary types, in terms of @c ==.
    00084      *  @param  x  A thing.
    00085      *  @param  y  Another thing.
    00086      *  @return   x != y
    00087      *
    00088      *  This function uses @c == to determine its result.
    00089      */
    00090     template <class _Tp>
    00091       inline bool
    00092       operator!=(const _Tp& __x, const _Tp& __y)
    00093       { return !(__x == __y); }
    00094
    00095     /**
    00096      *  @brief Defines @c > for arbitrary types, in terms of @c <.
    00097      *  @param  x  A thing.
    00098      *  @param  y  Another thing.
    00099      *  @return   x > y
    00100      *
    00101      *  This function uses @c < to determine its result.
    00102      */
    00103     template <class _Tp>
    00104       inline bool
    00105       operator>(const _Tp& __x, const _Tp& __y)
    00106       { return __y < __x; }
    00107
    00108     /**
    00109      *  @brief Defines @c <= for arbitrary types, in terms of @c <.
    00110      *  @param  x  A thing.
    00111      *  @param  y  Another thing.
    00112      *  @return   x <= y
    00113      *
    00114      *  This function uses @c < to determine its result.
    00115      */
    00116     template <class _Tp>
    00117       inline bool
    00118       operator<=(const _Tp& __x, const _Tp& __y)
    00119       { return !(__y < __x); }
    00120
    00121     /**
    00122      *  @brief Defines @c >= for arbitrary types, in terms of @c <.
    00123      *  @param  x  A thing.
    00124      *  @param  y  Another thing.
    00125      *  @return   x >= y
    00126      *
    00127      *  This function uses @c < to determine its result.
    00128      */
    00129     template <class _Tp>
    00130       inline bool
    00131       operator>=(const _Tp& __x, const _Tp& __y)
    00132       { return !(__x < __y); }
    00133
    00134   } // namespace rel_ops
    00135 } // namespace std
    00136
    00137 #endif /* _STL_RELOPS_H */